#include <time.h>
//#include <map>
#include <list>
#include <stdlib.h>
#include <fstream>
#include <math.h>
#include "grafo.h"
#include "mfset.h"
#include "heap.h"

using namespace std;

struct Datas{
  float latitud, longitud;
  int altura;
};

float dist(float ciu1_latitud, float ciu1_longitud,
           float ciu2_latitud, float ciu2_longitud) {
  float R = 6371, degToRad = 3.1415926536/180.0;
  float x1 = degToRad*ciu1_latitud;
  float y1 = degToRad*ciu1_longitud;
  float x2 = degToRad*ciu2_latitud;
  float y2 = degToRad*ciu2_longitud;
  float distancia = R * sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
  return distancia;
}

int numLineas(ifstream &fich){
  char linea[100];
  int i=0;
  while(fich.getline(linea,100)) i++;
  return i;
}

int main(int argc, char **argv){
  //clock_t ini;
  char buffer[60];
  ifstream datos;
  float dks;
  int altura_min, altura_max, dist_max;
  datos.open(argv[1]);
  if(!datos){
    cerr << "Fichero no existe\n";
    return 0;
  }
  //ini=clock();
  int nVert = numLineas(datos);
  //cout << "El fichero tiene " << nVert << " lineas\n\n";
  //cout << "Lineas fichero: " << (double)(clock()-ini)/CLOCKS_PER_SEC << endl;
  datos.close();
  
  Datas *datas = new Datas[nVert];
  
  datos.open(argv[1]);
  if(!datos){
    cerr << "Fichero no existe\n";
    return 0;
  }
  
  for(int i=0;i<nVert;i++){
    datos >> datas[i].latitud >> datas[i].longitud >> datas[i].altura;
    datos.getline(buffer, 60);
  }
  datos.close();
  
  
  int repeticiones = argc-2; // aquí empieza el MegaBucle
  for(int ajco=0; ajco<repeticiones; ajco=ajco+4){
    
    dist_max = atoi(argv[4+ajco]);
    altura_max = atoi(argv[3+ajco]);
    altura_min = atoi(argv[2+ajco]);
    
    Datas *datas2 = new Datas[nVert];
    for(int i=0;i<nVert;i++){
      datas2[i].altura = -1;
    }
    int s=0;
    for(int i=0;i<nVert;i++)
      if(datas[i].altura <= altura_max && datas[i].altura >= altura_min){
	datas2[s].latitud=datas[i].latitud;
	datas2[s].longitud=datas[i].longitud;
	datas2[s].altura=datas[i].altura;
	s++;
      }
    int numVert=s;
    //ini=clock();  
    Grafo g(numVert);
    //cout << "Crear Grafo: " << (double)(clock()-ini)/CLOCKS_PER_SEC << endl;
    
    //aquí hay que crear las aristas con sus distancias, usando función dist()
    // hacer igual que lo del WHITE, GRAY y BLACK del dijkstra
    //-----------------------------------------------------
    //ini=clock();
    
    for(int i=0;i<numVert;i++){
      for(int j=i+1;j<numVert;j++){ //repasar la condición j<nVert creo que está mal
	float distancia;
	if(i!=j){
	  distancia = dist(datas2[i].latitud,datas2[i].longitud,
			   datas2[j].latitud,datas2[j].longitud);
	  //cout << "Distancia de " << i << "-->" << j << " = " << distancia << endl;
	  if(distancia < dist_max){
	    g.addEdge(i, j, distancia);
	    g.addEdge(j, i, distancia);
	    //cout << i << " --> " << j << " = " << distancia << endl;
	  }
	}
      }
    }
    //cout << "Completar grafo: " << (double)(clock()-ini)/CLOCKS_PER_SEC << endl;  
    
    
    //ini=clock();
    //map <int,int> mapa;
    mfSet *mfs = new mfSet(numVert);
    for(int i=0;i<numVert;i++){
      arista *aux=g.get_vec()[i];
      while(aux){
	mfs->merge(i,aux->destino);
	aux = aux->sig;
      }
    }
    //for(int i=0;i<mfs->getn();i++) //RECUERDA BORRAR getn() Y getmfs()
    //  cout << "mfs[" <<i<<"] = " << mfs->getmfs()[i] << endl;
    //int *representantes = mfs->obtenRepresentantes();
    //for(int i=0;i<mfs->numSubconjuntos();i++)
    //  cout << "representante " << i << ": " << representantes[i] << endl;
    //for(int i=0;i<mfs->numSubconjuntos();i++) mapa[representantes[i]]=i;
    
    //cout << "MFSET: " << (double)(clock()-ini)/CLOCKS_PER_SEC << endl;
    
    //delete [] representantes;
    float *MaxVectorConjuntos = new float[mfs->numSubconjuntos()];
    for(int i=0;i<mfs->numSubconjuntos();i++) MaxVectorConjuntos[i]=-1;
    
    //ini=clock();
    /*list <int> cola;
      for(int p=0;p<numVert;p++){
      int s=0;
      arista *aux = g.get_vec()[p];
      while(aux){
      aux=aux->sig;
      s++;
      }
      if(s==1){
      cola.push_back(p);
      //cout << "p: " << mfs->find(p) << endl;
      }
      }*/
    
    //int pos;
    
    Cola **rGrafo = mfs->representantes_grafo();
    list <int> cola;
    for(int i=0;i<mfs->numSubconjuntos();i++){
      Cola *aux=rGrafo[i];
      bool halla=true;
      while(aux){  //recorro los nodos de un conjunto
        int s=0;
        //g.color[aux->i]=g.GRAY;
        arista *temp = g.get_vec()[aux->i];
        while(temp){  //miro cuantas aristas salen del nodo que estoy
          temp=temp->sig;
          s++;
        }
        //temp = g.get_vec()[aux->i];
        //int d = temp->destino;
        if(s==1 || s==2 || s==3){// && g.color[d]==g.WHITE){   //si el nodo sólo tiene una arista, me guardo el nodo para aplicarle el dijkstra
          cola.push_back(aux->i);
          halla=false;
        }
        //g.color[aux->i]=g.BLACK;
        aux=aux->sig;
      }
      if(halla){  // no se ha encontrado ningún nodo con una arista, y se tiene que recorrer todos los nodos del subgrafo
        Cola *aux2=rGrafo[i];
        while(aux2){
          dks = g.dijkstra(aux2->i,halla,i);
          if(MaxVectorConjuntos[i] < dks) MaxVectorConjuntos[i] = dks;
          aux2=aux2->sig;
        }
      }
      else{
        while(!cola.empty()){
          int e = cola.front();
          dks = g.dijkstra(e, halla,i);
          cola.pop_front();
          if(MaxVectorConjuntos[i] < dks) MaxVectorConjuntos[i] = dks;
	}
	Cola *aux2=rGrafo[i];
	list <int> cola2;
	while(aux2)
	  if(g.color[aux2->i] == g.WHITE){
	    cola2.push_back(aux2->i);
	    aux2=aux2->sig;
	  }
	  else
	    aux2=aux2->sig;
	
	while(!cola.empty()){
	  int e = cola.front();
	  dks = g.dijkstra(e, halla,i);
	  cola.pop_front();
	  if(MaxVectorConjuntos[i] < dks) MaxVectorConjuntos[i] = dks;
	}
      }
    }
    
/*else{
        while(!cola.empty()){
          int e = cola.front();
          dks = g.dijkstra(e, halla,i);
          cola.pop_front();
          if(MaxVectorConjuntos[i] < dks) MaxVectorConjuntos[i] = dks;
        }
        Cola *aux2=rGrafo[i];
        while(aux2){
          if(g.color[aux2->i] == g.WHITE){
            dks = g.dijkstra(aux2->i, halla,i);
            if(MaxVectorConjuntos[i] < dks) MaxVectorConjuntos[i] = dks;
            aux2=aux2->sig;
          }
          else
            aux2=aux2->sig;
        }
      }
*/



    /*for(int i=0;i<numVert;i++){
      dks = g.dijkstra(i);
      pos = mapa[mfs->find(i)];
      if(MaxVectorConjuntos[pos] < dks) MaxVectorConjuntos[pos] = dks;
      }*/
    /*while(!cola.empty()){
      int e = cola.front();
      dks = g.dijkstra(e);
      cola.pop_front();
      pos = mapa[mfs->find(e)];
      if(MaxVectorConjuntos[pos] < dks) MaxVectorConjuntos[pos] = dks;
    }*/
    //cout << "Hayar caminos: " << (double)(clock()-ini)/CLOCKS_PER_SEC << endl;
    
    //cout << "\n\n\nLos maximos caminos de cada subgrafo son:\n\n";
    
    //ini=clock();
    max_heap *heap = new max_heap(MaxVectorConjuntos, mfs->numSubconjuntos());
    //cout << "crear maxheap: " << (double)(clock()-ini)/CLOCKS_PER_SEC << endl;
    float max;
    int since=0, hasta=atoi(argv[5+ajco]);
    
    //ini=clock();
    while(since<hasta && max!=-1 && !heap->vacio()){
      if(!heap->maximo(max)){
	cerr << "error, no ha extraido nada\n";
	return 0;
      }
      heap->borrar_maximo();
      if(max!=-1 && max!=0) printf("%.2f", max);
      if(ajco != repeticiones-4 && max!=0) printf("\n");
      if(ajco == repeticiones-4 && since != hasta-1 && max!=0) printf("\n");
      since++;
    }
    max=-2;
  }
  
  delete [] datas;
  
  //cout << "operar con el maxheap: " << (double)(clock()-ini)/CLOCKS_PER_SEC << endl<<endl<<endl;
  
  return 0;
}
