#include "mfset.h"

mfSet::mfSet(int talla){
  nSubconjuntos=n=talla;
  mfs = new int[n];
  for(int i=0;i<n;i++)
    mfs[i]=-1;
}

mfSet::~mfSet(){
  delete [] mfs;
}

int mfSet::find(int x){
  int rx=x;
  while(mfs[rx]>=0)
    rx=mfs[rx];
  while(mfs[x] >= rx){
    int tmp=x;
    x = mfs[x];
    mfs[tmp]=rx;
  }
  return rx;
}

void mfSet::merge(int x, int y){
  int rx, ry;
  rx=find(x);
  ry=find(y);
  if(rx!=ry){
    nSubconjuntos--;
    if(mfs[rx]==mfs[ry]){
      mfs[ry]=rx;
      mfs[rx]--;
    }
    else if(mfs[rx]<mfs[ry])
      mfs[rx]=ry;
    else
      mfs[ry]=rx;
  }
}

int mfSet::numSubconjuntos(){
  return nSubconjuntos;
}

int *mfSet::obtenRepresentantes(){
  
  int *v = new int[nSubconjuntos];  
  
  int j=0;
  for(int i=0;i<n;i++){ 
    if(mfs[i]<0)
      v[j++]=i;
  }
  return v;
}

Cola **mfSet::representantes_grafo(){
  Cola **vector = new Cola*[nSubconjuntos];
  int *v=obtenRepresentantes();
  for(int i=0;i<nSubconjuntos;i++) vector[i]=0;
  for(int i=0;i<nSubconjuntos;i++){
    for(int j=0;j<n;j++){
      if(find(j) == v[i]){
        vector[i] = new Cola(j, vector[i]);
      }
    }
  }
  return vector;
}
